<template>
  <v-card class="mx-auto" max-width="300" tile>
    <v-list dense>
      <v-subheader>Choose wallet</v-subheader>
      <v-list-item-group color="primary">
        <v-list-item v-for="(item, i) in items" :key="i">
          <v-list-item-content @click="connect(item.id)">
            <v-list-item-title v-text="item.text"></v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list-item-group>
    </v-list>
  </v-card>
</template>

<script lang="ts">
import Vue from "vue"
import Component from "vue-class-component"
import { Prop, Model } from "vue-property-decorator"
import { ProviderController, ProviderControllerOptions } from "./../ProviderController"

@Component
export default class Web3Connector extends Vue {
  @Prop({
    type: Object,
    default: () => ({
      disableInjectedProvider: false,
      cacheProvider: true,
      providerOptions: {
        walletconnect: {
          rpc: {
            56: "https://bsc-dataseed.binance.org/",
          },
          chainId: 56,
        },
      },
    }),
  })
  providerOptions!: ProviderControllerOptions

  items: Array<{ text: string | undefined; id: string | undefined }> = []
  private providerController: ProviderController = new ProviderController(this.providerOptions)

  async created() {
    this.providerController.addEventListener("connect", async (providerEvent) => {
      const provider = (providerEvent as CustomEvent).detail
      this.$emit("connect", provider)
    })
    this.providerController.addEventListener("error", (errorEvent) => {
      const error = (errorEvent as CustomEvent).detail
      this.$emit("error", error)
    })

    const providers = this.providerController.getDisplayProviders()
    this.items = providers.map((p) => ({ text: p?.name, id: p?.id }))
  }

  clearCachedProvider() {
    this.providerController.clearCachedProvider()
  }

  setCachedProvider(id: string) {
    this.providerController.setCachedProvider(id)
  }

  async connect(data: any) {
    await this.providerController.connectTo(data)
  }
}
</script>